#! /bin/sh

: '@(#)ltroff.sh	4.2'

: To match the behavior of old troff, we must not use getopt.

libdir=LIBDIR
datadir=DATADIR

cart=default
tflag=0
mx=

if [ -r $libdir/troffflags ]
then
	troffflags=`cat $libdir/troffflags`" $troffflags"
else
	troffflags=
fi

while :
do
	case $# in
		0)	break ;;
	esac
	case $1 in
		--)	shift ; break ;;
		-)	break ;;
		-t)	tflag=1 ; shift ;;
		-c?*)	cart=`expr "$1" : '..\(.*\)'` ; shift ;;
		-c)	O=`basename $0`
			echo "$O: wild cartridgeless -c option" >&2
			exit 1 ;;
		-m*)	maybe=$libdir/tmac/tmac.`expr "$1" : '..\(.*\)'`
			if [ -f "$maybe" ]
			then
				mx="$maybe"
			else
				troffflags="$troffflags $1"
			fi
			shift ;;
		-*)	troffflags="$troffflags $1" ; shift ;;
		*)	break ;;
	esac
done

case $#$1 in
	0)  set x - ; shift ;;
	1=) O=`basename $0`
	    echo "$O: usage is $O [-ccartridge] [troff flag...] [file...]" >&2
	    exit 1 ;;
esac

case $cart in
	/*)	;;
	*)	cart=$datadir/$cart ;;
esac

: The ftXX is a workaround for a 4.3BSD troff bug;
: the -rv1 avoids cut marks being spit out when using -ms.

front='/usr/bin/troff -f -t -rv1 -F$cart/ftXX $troffflags $mx $datadir/tmac "$@"'

case $tflag in
	1)	eval $front ;;		# So "lpr -t" will work later.
	0)	if [ ! -f $libdir/lj4kermhosts ]
		then
			eval $front |
				lpr -t -1 $cart/R -2 $cart/I \
					-3 $cart/B -4 $cart/S
			break
		fi
		case $REMOTE in
			"")	REMOTE=`who am i |
					sed -n 's/.*(\([^.)]*\).*/\1/p'` ;;
		esac
		if fgrep -s -x -e "$REMOTE" $libdir/lj4kermhosts
		then
			eval $front | (
				awk 'BEGIN {
					printf "%cE%c[5i",27,27
					exit
				}'
				tlc $cart
				awk 'BEGIN {
					printf "%cE%c[4i",27,27
					exit
				}'
			)
		else
			eval $front |
				lpr -t -1 $cart/R -2 $cart/I \
					-3 $cart/B -4 $cart/S
		fi
		;;
esac
